"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assignmentsNextToEachother = void 0;
const helpers_1 = require("@wca/helpers");
const activities_1 = require("../lib/activities");
const util_1 = require("./util");
exports.assignmentsNextToEachother = (0, util_1.createConstraint)('Assignments Next To Each other', ({ wcif, activity, activities, person }) => {
    if (!(person === null || person === void 0 ? void 0 : person.assignments)) {
        return 0;
    }
    const allActivities = (0, activities_1.findAllActivities)(wcif);
    const staffAssignments = person === null || person === void 0 ? void 0 : person.assignments.filter((assignment) => assignment.assignmentCode.includes('staff') &&
        activities.find((a) => a.id === assignment.activityId)).map((assignment) => {
        // Implication from the filter means that activity is not undefined
        const _activity = allActivities.find((a) => a.id === assignment.activityId);
        return Object.assign(Object.assign({}, assignment), { activity: _activity, groupNumber: (0, helpers_1.parseActivityCode)(_activity.activityCode).groupNumber });
    }).sort((a, b) => a.activity.startTime.localeCompare(b.activity.startTime));
    const groupNumberA = (0, helpers_1.parseActivityCode)(activity.activityCode).groupNumber;
    if (activity.startTime < staffAssignments[0].activity.startTime) {
        const groupNumberB = (0, helpers_1.parseActivityCode)(staffAssignments[0].activity.activityCode).groupNumber;
        return groupNumberA && groupNumberB ? groupNumberA - groupNumberB : 0;
    }
    const groupNumberB = (0, helpers_1.parseActivityCode)(staffAssignments[staffAssignments.length - 1].activity.activityCode).groupNumber;
    return groupNumberA && groupNumberB
        ? -Math.abs(groupNumberA - groupNumberB)
        : 0;
});
//# sourceMappingURL=assignmentsNextToEachother.js.map