"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.avoidConflictingNames = void 0;
const util_1 = require("./util");
// TODO: make more sophisticated
exports.avoidConflictingNames = (0, util_1.createConstraint)('Avoid Conflicting Names', ({ wcif, person, assignmentCode, activity }) => {
    const initialFirstName = person.name.split(' ')[0];
    const peopleInActivity = wcif.persons.filter((p) => {
        var _a;
        return (_a = p.assignments) === null || _a === void 0 ? void 0 : _a.some((assignment) => assignment.assignmentCode === assignmentCode &&
            assignment.activityId === activity.id);
    });
    const peopleWithSimilarName = peopleInActivity.filter((p) => {
        const firstName = p.name.split(' ')[0];
        return (firstName === initialFirstName ||
            initialFirstName.startsWith(firstName) ||
            firstName.startsWith(initialFirstName));
    });
    return -peopleWithSimilarName.length;
});
//# sourceMappingURL=avoidConflictingNames.js.map