"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.balancedGroupSize = void 0;
const util_1 = require("./util");
/**
 * Creates a constraint that ensures that group sizes stay balanced.
 * @param assignmentCode
 * @returns the size of the activity
 */
exports.balancedGroupSize = (0, util_1.createConstraint)('Balanced Group Size', ({ wcif, activity, assignmentCode, options }) => {
    var _a;
    // Higher is better so we return negative numbers to prefer smaller groups.
    const personsInActivity = wcif.persons.filter((person) => {
        var _a;
        return ((options === null || options === void 0 ? void 0 : options.persons)
            ? options.persons.some((p) => p.registrantId === person.registrantId)
            : true) &&
            ((_a = person.assignments) === null || _a === void 0 ? void 0 : _a.some((assignment) => assignment.assignmentCode === assignmentCode &&
                assignment.activityId === activity.id));
    });
    const groupSize = personsInActivity.length;
    return (_a = -groupSize) !== null && _a !== void 0 ? _a : 0;
});
//# sourceMappingURL=balancedGroupSize.js.map