"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.groupBySpeed = void 0;
const helpers_1 = require("@wca/helpers");
const util_1 = require("./util");
const persons_1 = require("../lib/persons");
/**
 * Constraint that ensures that the people in this group have similar speeds.
 * @param assignmentCode
 * @returns null if the person's ranking is outside of the min and max ranking, otherwise a 0
 */
exports.groupBySpeed = (0, util_1.createConstraint)('Balanced Speed', (_a) => {
    var { wcif, activity, cluster, person } = _a, props = __rest(_a, ["wcif", "activity", "cluster", "person"]);
    const options = props.options;
    const activityOptions = options[activity.activityCode];
    if (!activityOptions)
        return null;
    const { eventId, roundNumber } = (0, helpers_1.parseActivityCode)(activity.activityCode);
    const event = wcif.events.find((event) => event.id === eventId);
    const personRankings = cluster.sort((0, persons_1.byPROrResult)(event, roundNumber));
    const ranking = personRankings.findIndex((p) => p.registrantId === person.registrantId) +
        0;
    return ranking > activityOptions.minRanking &&
        ranking < activityOptions.maxRanking
        ? 0
        : null;
});
//# sourceMappingURL=groupBySpeed.js.map