"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mustNotHaveConflictingAssignments = void 0;
const activities_1 = require("../lib/activities");
const util_1 = require("./util");
/**
 * Constraint that ensures that the person does not have conflicting assignments.
 * That is don't assign a person to two activities that overlap.
 */
exports.mustNotHaveConflictingAssignments = (0, util_1.createConstraint)('Must Not Have Conflicting Assignments', ({ wcif, activity, person }) => {
    var _a;
    const allActivities = (0, activities_1.findAllActivities)(wcif);
    return ((_a = person.assignments) === null || _a === void 0 ? void 0 : _a.some((assignment) => {
        const assignedActivity = allActivities.find((a) => a.id === assignment.activityId);
        if (!assignedActivity) {
            return false;
        }
        return (0, activities_1.activitiesOverlap)(activity, assignedActivity);
    }))
        ? null
        : 0;
});
//# sourceMappingURL=mustNotHaveConflictingAssignments.js.map