"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mustNotHaveOtherAssignments = void 0;
const util_1 = require("./util");
/**
 * @deprecated use mustNotHaveConflictingAssignments
 *
 * Requires the person to not have any other assignments in the activity.
 * Easily rules out giving multiple assignments to someone for the same activity.
 * @param assignmentCode
 * @returns
 */
exports.mustNotHaveOtherAssignments = (0, util_1.createConstraint)('Must Not Have Other Assignments', ({ activity, person }) => {
    var _a;
    const assignments = ((_a = person.assignments) === null || _a === void 0 ? void 0 : _a.filter((assignment) => assignment.activityId === activity.id)) || [];
    if ((assignments === null || assignments === void 0 ? void 0 : assignments.length) > 0) {
        return null;
    }
    return 0;
});
//# sourceMappingURL=mustNotHaveOtherAssignments.js.map