"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sameStageAsOtherAssignments = void 0;
const activities_1 = require("../lib/activities");
const util_1 = require("./util");
exports.sameStageAsOtherAssignments = (0, util_1.createConstraint)('Same Stage As Other Assignments', ({ wcif, activity, activities, person }) => {
    var _a;
    const assignments = (_a = person.assignments) === null || _a === void 0 ? void 0 : _a.filter((assignment) => activities.find((a) => a.id === assignment.activityId));
    if (!(assignments === null || assignments === void 0 ? void 0 : assignments.length)) {
        return 0;
    }
    const currentRoom = (0, activities_1.roomByActivity)(wcif, assignments[0].activityId);
    const activityRoom = (0, activities_1.roomByActivity)(wcif, activity.id);
    if ((currentRoom === null || currentRoom === void 0 ? void 0 : currentRoom.id) === (activityRoom === null || activityRoom === void 0 ? void 0 : activityRoom.id)) {
        return 1;
    }
    return 0;
});
//# sourceMappingURL=sameStageAsOtherAssignments.js.map