"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.shouldFollowCompetitorAssignment = void 0;
const helpers_1 = require("@wca/helpers");
const util_1 = require("./util");
exports.shouldFollowCompetitorAssignment = (0, util_1.createConstraint)('Should Follow Competitor Assignment', ({ person, activity, activities }) => {
    var _a;
    const uniqueGroupCount = new Set(activities.map((a) => a.activityCode))
        .size;
    const competitorAssignment = (_a = person.assignments) === null || _a === void 0 ? void 0 : _a.find((assignment) => assignment.assignmentCode === 'competitor' &&
        activities.some((a) => a.id === assignment.activityId));
    if (!competitorAssignment) {
        return 0;
    }
    const competitorActivity = activities.find((activity) => activity.id === competitorAssignment.activityId);
    if (!competitorActivity) {
        return 0;
    }
    const competitorGroupNumber = (0, helpers_1.parseActivityCode)(competitorActivity.activityCode).groupNumber;
    const judgeGroupNumber = (0, helpers_1.parseActivityCode)(activity.activityCode).groupNumber;
    if (!competitorGroupNumber || !judgeGroupNumber) {
        return 0;
    }
    return judgeGroupNumber === (competitorGroupNumber % uniqueGroupCount) + 1
        ? 1
        : 0;
});
//# sourceMappingURL=shouldFollowCompetitorAssignment.js.map