"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uniqueAssignment = void 0;
const util_1 = require("./util");
/**
 * For the given activities, ensures that a person has one assignment with that assignmentCode
 * Prevents people from having multiple competitor assignments for the activities.
 * @param assignmentCode
 * @returns
 */
exports.uniqueAssignment = (0, util_1.createConstraint)('Unique Assignment', ({ activities, assignmentCode, person }) => {
    var _a;
    const assignments = ((_a = person.assignments) === null || _a === void 0 ? void 0 : _a.filter((assignment) => assignment.assignmentCode === assignmentCode)) || [];
    if (assignments.some((assignment) => activities.some((activity) => activity.id === assignment.activityId))) {
        return null;
    }
    return 0;
});
//# sourceMappingURL=uniqueAssignmentCode.js.map