"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.activitiesOverlap = exports.roomByActivity = exports.isParentActivityCode = exports.findAllActivities = exports.allChildActivities = exports.allChildActivitiesInRoom = exports.rooms = void 0;
const helpers_1 = require("@wca/helpers");
const rooms = (wcif) => wcif.schedule.venues.flatMap((venue) => venue.rooms);
exports.rooms = rooms;
const allChildActivitiesInRoom = (room) => room.activities.flatMap((activity) => (0, exports.allChildActivities)(activity));
exports.allChildActivitiesInRoom = allChildActivitiesInRoom;
const allChildActivities = (activity) => {
    var _a;
    return ((_a = activity.childActivities) === null || _a === void 0 ? void 0 : _a.flatMap((activity) => [
        activity,
        ...(0, exports.allChildActivities)(activity),
    ])) || [];
};
exports.allChildActivities = allChildActivities;
const findAllActivities = (wcif) => (0, exports.rooms)(wcif).flatMap((room) => (0, exports.allChildActivitiesInRoom)(room));
exports.findAllActivities = findAllActivities;
const isParentActivityCode = (parentActivityCode, childActivityCode) => {
    const parent = (0, helpers_1.parseActivityCode)(parentActivityCode);
    const child = (0, helpers_1.parseActivityCode)(childActivityCode);
    if (parent.eventId !== child.eventId) {
        return false;
    }
    return (parent.eventId === child.eventId &&
        (!parent.roundNumber || parent.roundNumber === child.roundNumber) &&
        (!parent.attemptNumber || parent.attemptNumber === child.attemptNumber) &&
        (!parent.groupNumber || parent.groupNumber === child.groupNumber));
};
exports.isParentActivityCode = isParentActivityCode;
const findActivityById = (activites, activityId) => activites.some(({ id, activities, childActivities }) => id === activityId ||
    (activities ? findActivityById(activities, activityId) : false) ||
    (childActivities ? findActivityById(childActivities, activityId) : false));
const roomByActivity = (wcif, activityId) => { var _a; return (_a = (0, exports.rooms)(wcif)) === null || _a === void 0 ? void 0 : _a.find((room) => findActivityById(room.activities, activityId)); };
exports.roomByActivity = roomByActivity;
const activitiesOverlap = (first, second) => new Date(first.startTime) < new Date(second.endTime) &&
    new Date(second.startTime) < new Date(first.endTime);
exports.activitiesOverlap = activitiesOverlap;
//# sourceMappingURL=activities.js.map