import { Activity, Competition, Person } from '@wca/helpers';
import { ConstraintAndWeight, Generator, GeneratorProps } from './types';
export declare const createGroupActivity: (id: number, roundActivity: Activity, groupNumber: number, startTime: string | null, endTime: string | null) => Activity;
/**
 * Creates a new version of data with the data from initial for each item where the `id` prop matches.
 */
export declare const upsert: <T extends {
    id: string | number;
}>(initial: T[], data: T[]) => T[];
/**
 * Returns a new person array with person's assignments generated based on the given constraints
 */
export declare const assignPersons: ({ wcif, cluster, activities, constraints, assignmentCode, options, }: {
    wcif: Competition;
    cluster: Person[];
    activities: Activity[];
    constraints: ConstraintAndWeight[];
    assignmentCode: string;
    options: Record<string, any>;
}) => Person[];
/**
 * A cluster is a subset of persons.
 * The default constraints require that the registraiton status is accepted
 *
 * @deprecated
 * @param persons
 * @param options
 * @returns
 */
export declare const createCluster: (persons: Person[], options?: {
    firstTimer?: boolean;
    roles?: string[];
}) => Person[];
export declare const applyGenerators: ({ wcif: initialWcif, generators, }: {
    wcif: Competition;
    generators: {
        generator: Generator;
        props: Omit<GeneratorProps, 'wcif'>;
    }[];
}) => Competition;
//# sourceMappingURL=utils.d.ts.map